//+------------------------------------------------------------------+
//|                                                        12345.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

// 
// FIBO 
//
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
//---- indicator parameters
extern int ExtDepth = 12;
extern int ExtDeviation = 5;
extern int ExtBackstep = 3;
//---- 
color gFibo1 = Green;
color gFibo2 = Blue;
int gFiboStyle1 = 0;
int gFiboStyle2 = 3;
//---- indicator buffers
double ExtMapBuffer[];
double ExtMapBuffer2[];
double Outbuff[]; 
int OldLastZigZag, OldPreviousZigZag;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
    IndicatorBuffers(3);
    //---- drawing settings
    SetIndexStyle(0,DRAW_SECTION);
    //---- indicator buffers mapping
    SetIndexBuffer(0,ExtMapBuffer);
    SetIndexBuffer(1,ExtMapBuffer2);
    SetIndexEmptyValue(0,0.0);
    ArraySetAsSeries(ExtMapBuffer,true);
    ArraySetAsSeries(ExtMapBuffer2,true);
    SetIndexBuffer(2,Outbuff);
    //---- indicator short name
    IndicatorShortName("FibodrawerYZ");
    //---- initialization done
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+  
int deinit() 
  {
ObjectsDeleteAll( 0, OBJ_FIBO);


  }
//+------------------------------------------------------------------+
//| Custom indicator start  function                                  | 
//+------------------------------------------------------------------+
int start()
  {
    int shift, back, lasthighpos, lastlowpos;
    double val, res;
    double curlow, curhigh, lasthigh, lastlow;
 
    for(shift = Bars - ExtDepth; shift >= 0; shift--)
      {
        val = Low[Lowest(NULL, 0, MODE_LOW, ExtDepth, shift)];
        if(val == lastlow) 
            val=0.0;
        else 
          { 
            lastlow = val; 
            if((Low[shift] - val) > (ExtDeviation*Point)) 
                val = 0.0;
            else
              {
                for(back = 1; back <= ExtBackstep; back++)
                  {
                    res = ExtMapBuffer[shift+back];
                    if((res != 0) && (res > val)) 
                        ExtMapBuffer[shift+back] = 0.0; 
                  }
              }
          } 
        ExtMapBuffer[shift] = val;
        //--- high
        val = High[Highest(NULL, 0, MODE_HIGH, ExtDepth, shift)];
        if(val == lasthigh) 
            val = 0.0;
        else 
          {
            lasthigh = val;
            if((val - High[shift]) > (ExtDeviation*Point)) 
                val = 0.0;
            else
              {
                for(back = 1; back <= ExtBackstep; back++)
                  {
                    res = ExtMapBuffer2[shift+back];
                    if((res != 0) && (res < val)) 
                        ExtMapBuffer2[shift+back] = 0.0; 
                  } 
              }
          }
        ExtMapBuffer2[shift]=val;
      }
    // final cutting 
    lasthigh = -1; 
    lasthighpos = -1;
    lastlow = -1;  
    lastlowpos = -1;

    for(shift = Bars - ExtDepth; shift >= 0; shift--)
      {
        curlow = ExtMapBuffer[shift];
        curhigh = ExtMapBuffer2[shift];
        if((curlow == 0) && (curhigh == 0)) 
            continue;
        //---
        if(curhigh != 0)
          {
            if(lasthigh > 0) 
              {
                if(lasthigh < curhigh) 
                    ExtMapBuffer2[lasthighpos] = 0;
                else 
                    ExtMapBuffer2[shift] = 0;
              }
            //---
            if(lasthigh < curhigh || lasthigh < 0)
              {
                lasthigh = curhigh;
                lasthighpos = shift;
              }
                lastlow = -1;
          }
        //----
        if(curlow != 0)
          {
            if(lastlow > 0)
              {
                if(lastlow > curlow) 
                    ExtMapBuffer[lastlowpos] = 0;
                else 
                    ExtMapBuffer[shift] = 0;
              }
            //---
            if((curlow < lastlow) || (lastlow < 0))
              {
                lastlow = curlow;
                lastlowpos = shift;
              } 
            lasthigh = -1;
          }
        }
      for(shift = Bars - 1; shift >= 0; shift--)
        {
          if(shift >= Bars - ExtDepth) 
              ExtMapBuffer[shift] = 0.0;
          else
            {
              res = ExtMapBuffer2[shift];
              if(res != 0.0) 
                  ExtMapBuffer[shift] = res;
            }
        }
      int i = 0;
      int LastZigZag, PreviousZigZag;
   
      int h = 0;
      while( ExtMapBuffer[h] == 0 && ExtMapBuffer2[h] == 0) 
        {
          h++;
        }
      LastZigZag = h;
      h++;
      while(ExtMapBuffer[h] == 0 && ExtMapBuffer2[h] == 0) 
        {
          h++;
        }
      PreviousZigZag = h;
      if(OldLastZigZag != LastZigZag || OldPreviousZigZag != PreviousZigZag) 
        {
          OldLastZigZag = LastZigZag;
          OldPreviousZigZag = PreviousZigZag;
          ObjectDelete("FiboYZ" + Period());
          ObjectCreate("FiboYZ" + Period(), OBJ_FIBO, 0, Time[PreviousZigZag], 
                       ExtMapBuffer[LastZigZag], Time[LastZigZag], 
                       ExtMapBuffer[PreviousZigZag]);
          ObjectSet("FiboYZ" + Period(),OBJPROP_FIBOLEVELS, 13);
      
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+0, 0);
          ObjectSetFiboDescription("FiboYZ" + Period(), 0, "0 %$ " + PeriodSTR(Period()));
 
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+1, 0.236);
          ObjectSetFiboDescription("FiboYZ" + Period(), 1, "23.6 %$ " + PeriodSTR(Period()));
 
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+2, 0.382);
          ObjectSetFiboDescription("FiboYZ" + Period(), 2, "38.2 %$ " + PeriodSTR(Period()));
 
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+3, 0.500);
          ObjectSetFiboDescription("FiboYZ" + Period(), 3, "50.0 %$ " + PeriodSTR(Period()));
  
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+4, 0.618);
          ObjectSetFiboDescription("FiboYZ" + Period(), 4, "61.8 %$ " + PeriodSTR(Period()));
 
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+5, 1.00);
          ObjectSetFiboDescription("FiboYZ" + Period(), 5, "100 %$ " + PeriodSTR(Period()));
    
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+6, 1.618);
          ObjectSetFiboDescription("FiboYZ" + Period(), 6, "161.8 %$ " + PeriodSTR(Period()));
  
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+7, 2.618);
          ObjectSetFiboDescription("FiboYZ" + Period(), 7, "261.8 %$ " + PeriodSTR(Period()));
 
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+8, 4.236);
          ObjectSetFiboDescription("FiboYZ" + Period(), 8, "423.6 %$ " + PeriodSTR(Period()));
//------------------------- -------------------------------------------------------
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+9, 1.115);
          ObjectSetFiboDescription("FiboYZ" + Period(), 9, "115 %$ " + PeriodSTR(Period()));
    
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+10, 1.27);
          ObjectSetFiboDescription("FiboYZ" + Period(), 10, "127 %$ " + PeriodSTR(Period()));
  
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+11, 0.887);
          ObjectSetFiboDescription("FiboYZ" + Period(), 11, "88.7 %$ " + PeriodSTR(Period()));
 
          ObjectSet("FiboYZ" + Period(), OBJPROP_FIRSTLEVEL+12, 0.764);
          ObjectSetFiboDescription("FiboYZ" + Period(), 12, "76.4 %$ " + PeriodSTR(Period()));      
          
          
          
          
          ObjectSet("FiboYZ" + Period(), OBJPROP_COLOR, gFibo1);
          ObjectSet("FiboYZ" + Period(), OBJPROP_LEVELCOLOR, gFibo2);
          ObjectSet("FiboYZ" + Period(), OBJPROP_STYLE, gFiboStyle1);
          ObjectSet("FiboYZ" + Period(), OBJPROP_LEVELSTYLE, gFiboStyle2);
//-------------------------   -----------------------------------------
Outbuff[1]= ObjectGet( "FiboYZ" + Period(), OBJPROP_PRICE1); 
Outbuff[2]= ObjectGet( "FiboYZ" + Period(), OBJPROP_PRICE2);         
 
        }
    }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string  PeriodSTR(int iTF)
  {
    if(iTF == 1) // Period
        return("M1");
    if(iTF == 5)
        return("M5");
    if(iTF == 15)
        return("M15");
    if(iTF == 30)
        return("M30");
    if(iTF == 60)
        return("H1");
    if(iTF == 240)
        return("H4");
    if(iTF == 1440)
        return("D1");
    if(iTF == 10080)
        return("W1");
    if(iTF == 43200)
        return("MN1");
  }//+------------------------------------------------------------------+